import 'dart:async';
import 'package:bolter_flutter/bolter_flutter.dart';
import 'package:flutter/material.dart';

part 'presenter/presenter.dart';
part 'presenter/presenter_provider.dart';

class BolterProvider extends StatelessWidget {
  final DependenciesContainer _container;
  final Widget child;

  const BolterProvider({
    required DependenciesContainer container,
    Key? key,
    required this.child,
  })  : _container = container,
        super(key: key);

  static BolterProvider of(BuildContext context) =>
      context.findAncestorWidgetOfExactType<BolterProvider>()!;

  static final _bolter = Bolter();

  T dependency<T>({bool existingInstance = false}) => _container.dependency<T>(existingInstance: existingInstance);

  DependenciesContainer get dependenciesContainer => _container;

  @override
  Widget build(BuildContext context) => child;
}


extension BolterProviderExtension on BuildContext {
  BolterProvider bolterProvider() => BolterProvider.of(this);
}
